<!DOCTYPE html>
<html lang="en">
<head>
	<meta charset="UTF-8">
	<meta name="viewport" content="width=device-width, initial-scale=1.0">
	<meta http-equiv="Cache-Control" content="no-cache, no-store, must-revalidate">
	<meta http-equiv="Pragma" content="no-cache">
	<meta http-equiv="Expires" content="0">
	<title>Weilianqi</title>
	<link rel="stylesheet" href="../style.css">
</head>

<body>
<header>
<nav>
	<ul>
		<li><a href="/">Home</a></li>
		<li><a href="/play.html">Play</a></li>
		<li><a href="/articles.html">Articles</a></li>
	</ul>
</nav>
</header>
<main>
<h1>A rock paper scissors blockchain</h1>

<p><small>Published 2/2/2022.</small></p>

<p>This article goes through how to scaffold a blockchain that implements a very simple game. The starport version used is 0.19.1 and Golang v1.16.2. For details on how to install starport check out <a href="https://docs.starport.com/guide/install.html" target="_blank">the official website</a>. I simply put the binary in my Cosmos folder and run it by referencing the relative path, this makes upgrading easier.</p>

<p>Start by navigating to your Cosmos folder and run the following command with your choice of host repository, if you don't plan to upload your code anywhere it doesn't really matter what you pick, a popular choice is github.com/cosmonaut/. Since I will put the code in <a href="https://gitlab.com/marcus.appelros/rps" target="_blank">my personal repository</a> the command looks as follows: <code>starport scaffold chain gitlab.com/marcus.appelros/rps --no-module --address-prefix rps</code></p>

<p>Next run <code>cd rps</code> and scaffold the main module. We plan to award players with tokens so add the bank module as a dependency: <code>starport scaffold module rps --dep bank</code></p>

<p>How should games be started? You could allow people to send challenges, either public or private, but a simpler method is to have a queue where when two people have joined it a game is started. Let's create the Queue datastructure: <code>starport scaffold single queue address --no-message</code></p>

<p>If we now start the chain with <code>starport chain serve</code> and try to view the queue with <code>rpsd query rps show-queue</code> we will get an error. This is because it is initiated to nil in types/genesis.go (all files we will be modifying are located in x/rps/), go ahead and change this to: <code>Queue: &Queue{""},</code></p>

<p>Reset the chain with <code>starport chain serve -r</code> and the command should work. Joining the queue will sometimes start a match, so lets create a list to store these in:</p>
<pre class="prebox"><code>starport scaffold list match player1 player2 player1move:uint player2move:uint winner:uint --no-message
</code></pre>

<p>Now we are ready to implement the transaction to join the queue. Run <code>starport scaffold message join-queue</code> then replace the TODO in keeper/msg_server_join_queue.go with the following:</p>
<pre class="prebox"><code>queue, found := k.Keeper.GetQueue(ctx)
if !found {
    panic("Queue not found")
}
if queue.Address == "" {
  queue.Address = msg.Creator
} else if msg.Creator == queue.Address {
  return nil, types.ErrAlreadyInQueue
} else {
  var match = types.Match {
    Player1:	queue.Address,
    Player2:	msg.Creator,
  }
  k.AppendMatch(ctx, match)
  queue.Address = ""
}
k.Keeper.SetQueue(ctx, queue)
</code></pre>

<p>Additionally replace the sample error in types/errors.go with:
<pre class="prebox"><code>ErrAlreadyInQueue = sdkerrors.Register(ModuleName, 1100, "Address already in queue")</code></pre>

<p>Now if you start the chain and run <code>rpsd tx rps join-queue --from alice -y</code> in a separate terminal followed by <code>rpsd q rps show-queue</code> you should see the address field populated. Lets rerun the tx command with the from flag changed to bob, then we can confirm a match has begun with <code>rpsd q rps list-match</code></p>

<p>If you like you can also implement a message to leave the queue, learning is much more efficient when not simply copy pasting code.</p>

<p>Before we can submit moves to our matches we must define the rules of the game. Make a new folder with <code>mkdir x/rps/rules</code> and create a .go file there with the following contents:</p>
<pre class="prebox"><code>package rules

func DetermineWinner(player1move, player2move uint64) uint64 {
  if player1move == 0 || player2move == 0 {
    return 0
  }
  if player1move == player2move {
    return 3
  }
  if player1move == player2move + 1 || player1move == player2move - 2 {
    return 1
  }
  if player2move == player1move + 1 || player2move == player1move - 2 {
    return 2
  }
  return 4
}
</code></pre>

<p>Now we are ready to scaffold the submit-move message: <code>starport scaffold message submit-move matchId:uint moveId:uint</code></p>

<p>To prevent people submitting arbitrary hand gestures we add the following code to ValidateBasic in types/message_submit_move.go:</p>
<pre class="prebox"><code>if msg.MoveId != 1 && msg.MoveId != 2 && msg.MoveId != 3 {
  return ErrInvalidMove
}
</code></pre>

<p>Don't forget to register this new error in types/errors.go:
<pre class="prebox"><code>ErrInvalidMove = sdkerrors.Register(ModuleName, 1110, "Move not rock (1), paper (2) or scissors (3)")
</code></pre>

<p>Next open up keeper/msg_server_submit_move.go and add your version of "gitlab.com/marcus.appelros/rps/x/rps/rules" to the list of imports. Then replace the TODO with the following code:</p>
<pre class="prebox"><code>match, found := k.GetMatch(ctx, msg.MatchId)
if !found {
  return nil, types.ErrMatchNotFound
}
if match.Winner > 0 {
  return nil, types.ErrMatchCompleted
}
if msg.Creator == match.Player1 {
  match.Player1Move = msg.MoveId
} else if msg.Creator == match.Player2 {
  match.Player2Move = msg.MoveId
} else {
  return nil, types.ErrNotInMatch
}
if match.Player1Move > 0 && match.Player2Move > 0 {
  match.Winner = rules.DetermineWinner(match.Player1Move, match.Player2Move)
  player1acc, err := sdk.AccAddressFromBech32(match.Player1)
  if err != nil {
    panic(err)
  }
  player2acc, err := sdk.AccAddressFromBech32(match.Player2)
  if err != nil {
    panic(err)
  }
  if match.Winner == 3 {
    err = k.bankKeeper.MintCoins(ctx, types.ModuleName, sdk.NewCoins(sdk.NewCoin("draw", sdk.NewInt(2))))
    if err != nil {
      panic(err)
    }
    err = k.bankKeeper.SendCoinsFromModuleToAccount(ctx, types.ModuleName, player1acc, sdk.NewCoins(sdk.NewCoin("draw", sdk.NewInt(1))))
    if err != nil {
      panic(err)
    }
    err = k.bankKeeper.SendCoinsFromModuleToAccount(ctx, types.ModuleName, player2acc, sdk.NewCoins(sdk.NewCoin("draw", sdk.NewInt(1))))
    if err != nil {
      panic(err)
    }
  } else {
    err = k.bankKeeper.MintCoins(ctx, types.ModuleName, sdk.NewCoins(sdk.NewCoin("win", sdk.NewInt(1))))
    if err != nil {
      panic(err)
    }
    if match.Winner == 1 {
      err = k.bankKeeper.SendCoinsFromModuleToAccount(ctx, types.ModuleName, player1acc, sdk.NewCoins(sdk.NewCoin("win", sdk.NewInt(1))))
      if err != nil {
        panic(err)
      }
    } else if match.Winner == 2 {
      err = k.bankKeeper.SendCoinsFromModuleToAccount(ctx, types.ModuleName, player2acc, sdk.NewCoins(sdk.NewCoin("win", sdk.NewInt(1))))
      if err != nil {
        panic(err)
      }
    }
  }
}
k.SetMatch(ctx, match)
</code></pre>
<p>To use the functions from the bank module we have to register them in types/expected_keepers.go under the appropriate interface:</p>
<pre class="prebox"><code>MintCoins(ctx sdk.Context, moduleName string, amt sdk.Coins) error
SendCoinsFromModuleToAccount(ctx sdk.Context, senderModule string, recipientAddr sdk.AccAddress, amt sdk.Coins) error
</code></pre>

<p>Also register the new errors in types/errors.go:
<pre class="prebox"><code>ErrMatchNotFound = sdkerrors.Register(ModuleName, 1120, "Match not found")
ErrMatchCompleted = sdkerrors.Register(ModuleName, 1130, "Match already completed")
ErrNotInMatch = sdkerrors.Register(ModuleName, 1140, "You are not in this match!")
</code></pre>

<p>Alright, the logic is complete and we are ready to give it a whirl! Start the blockchain and run some variation of the following commands:</p>
<pre class="prebox"><code>rpsd tx rps join-queue --from alice -y
rpsd tx rps join-queue --from bob -y
rpsd q rps list-match
rpsd tx rps submit-move 0 3 --from alice -y
rpsd tx rps submit-move 0 3 --from bob -y
</code></pre>

<p>Verify that some coins were sent out with <code>rpsd q bank balances $(rpsd keys show alice -a)</code></p>

<p>Where to go from here? The list is endless, obviously the state of the rock paper scissors game is flawed since one can simply query the list of matches to see what the opponent picked, to implement a game with hidden variables simply removing them from the output of a query is not enough though as the values can still be extracted from the database files. One also needs to make it harder to obtain the minted tokens, so that anyone with scripting skills doesn't have access to an unlimited amount. If you want to implement the time limit from <a href="http://tutorials.cosmos.network/academy/4-my-own-chain/game-fifo.html" target="_blank">the checkers tutorial</a> you can do this by changing NoFifoIdKey to the maximum value storable in a uint.</p>

<p>After a while it becomes unwieldy to look up the match ids directly from the list of matches, one could solve this by adding a map that resolves addresses to associated games and then implementing a migration, however that deserves <a href="rps-migration.html">a dedicated article</a>.</p>

<br><br><br><br><br><br><br>
</main>
<footer>
<nav>
	<ul>
		<li><a href="/">Home</a></li>
		<li><a href="/play.html">Play</a></li>
		<li><a href="/articles.html">Articles</a></li>
	</ul>
</nav>
</footer>
</body>

</html>
